【容斥原理】Codeforces Round #428 (Div. 2) D. Winter is here

给你一个序列,让你对于所有gcd不为1的子序列,计算它们的gcd*其元素个数之和。

设sum(i)为i的倍数的数的个数,可以通过容斥算出来。

具体看这个吧:http://blog.csdn.net/jaihk662/article/details/77161436。

注意1*C(n,1)+2*C(n,2)+...+n*C(n,n)=n*2^(n-1)。

#include<cstdio>
using namespace std;
typedef long long ll;
#define MOD 1000000007ll
int n;
int a[200005],cnt[1000005];
ll sum[1000005],ans,pw[1000005];
int main(){
	pw[0]=1;
	for(int i=1;i<=1000000;++i){
		pw[i]=(pw[i-1]*2ll)%MOD;
	}
	scanf("%d",&n);
	for(int i=1;i<=n;++i){
		scanf("%d",&a[i]);
		++cnt[a[i]];
	}
	for(int i=1000000;i>=2;--i){
		int all=cnt[i];
		for(int j=i*2;j<=1000000;j+=i){
			sum[i]=(sum[i]+MOD-sum[j])%MOD;
			all+=cnt[j];
		}
		sum[i]=(sum[i]+((ll)all*pw[all-1])%MOD)%MOD;
		ans=(ans+((ll)i*sum[i])%MOD)%MOD;
	}
	printf("%I64d\n",ans);
	return 0;
}
时间: 2024-08-24 17:24:00

【容斥原理】Codeforces Round #428 (Div. 2) D. Winter is here的相关文章

Codeforces Round #428 (Div. 2) D. Winter is here[数论II][容斥原理]

传送门:http://codeforces.com/contest/839/problem/D Examples input 33 3 1 output 12 input 42 3 4 6 output 39 Note In the first sample the clans are {1},?{2},?{1,?2} so the answer will be 1·3?+?1·3?+?2·3?=?12 题解:当有n个数为x的倍数时 gcd为x对答案的贡献为$1*C_n^1+2*C_n^2+..

Codeforces Round #428 (Div. 2) D. Winter is here 数学

链接: http://codeforces.com/contest/839/problem/D 题意: 给出一些数,求取出一些数,当他们的GCD大于0时,将数量乘GCD累加到答案上,求累加和. 题解: 这道题比赛的时候忘了考虑重复了,wa掉之后发现可能会出现重复,然而又不会写了.. 这道题需要知道一个公式就是 1*C(n,1)+2*C(n,2)+3*C(n,3)+...+n*C(n,n) = n*2^(n-1) 我们枚举GCD,统计为其倍数的数字数量,先假定其能组成的集合数为贡献, 但是我们发现

(容斥)Codeforces Round #428 (Div. 2) D. Winter is here

D. Winter is here time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Winter is here at the North and the White Walkers are close. John Snow has an army consisting of n soldiers. While the res

Codeforces Round #428 (Div. 2) D. Winter is here[数论 II]

题目:http://codeforces.com/contest/839/problem/D 题意:找出每种情况使得所有数字gcd不为1,对答案的贡献为gcd值乘数字个数. 题解:因为数字不大,可以哈希出每种数字的个数,然后从后往前,f[i]代表在gcd==i时存在的数字搭配种数.每次计算i时,要减去计算过的种数,所以从后向前计算.每个数字贡献次数为${2}^{sum-1}$(写二进制数的情况可以观察出来),所有数字贡献为$sum*{2}^{sum-1}$ 2次x次方可以先预处理取模出来. 1

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #428 (Div. 2) A-C

A. Arya and Bran 水题 #include <iostream> #include <cstring> #include <cstdio> #include <algorithm> #include <queue> #include <vector> #include <iomanip> #include <math.h> #include <map> using namespace

Codeforces Round #428 (Div. 2) C. Journey

There are n cities and n?-?1 roads in the Seven Kingdoms, each road connects two cities and we can reach any city from any other by the roads. Theon and Yara Greyjoy are on a horse in the first city, they are starting traveling through the roads. But

Tutorial CodeForces Round 289 (Div.2) (Second Winter Computer Camp Selection 2015) 题解

题目链接:点击打开链接 A: #include <cstdio> #include <vector> #include <algorithm> #include <iostream> #include <map> #include <set> #include <queue> #include <cstring> #include <cmath> #include <string> us

CodeForces839B[思维] Codeforces Round #428 (Div. 2)

#include <bits/stdc++.h> using namespace std; int n, k; const int MOD = 1000000007; int a[105], cnt[5]; void solve() { int t; cnt[4]=n,cnt[2]=2*n; for(int i=0;i<k;i++){ t=min(a[i]/4,cnt[4]); a[i]-=4*t; cnt[4]-=t; } cnt[2]+=cnt[4]; cnt[1]+=cnt[4];